Compare commits

...

6 Commits

Author SHA1 Message Date
c76193dcc5 feat: adapt on nginx versionning
All checks were successful
Continuous Integration / lint_n_build (push) Successful in 35s
Continuous Delivery / build_n_upload (push) Successful in 25s
2026-08-30 14:27:43 +02:00
72dea1d665 doc: update badge
All checks were successful
Continuous Integration / lint_n_build (push) Successful in 19s
2026-04-19 14:26:34 +02:00
1a14fbb5f1 doc: update pkg repo owner
All checks were successful
Continuous Integration / lint_n_build (push) Successful in 1m53s
2026-04-19 14:16:12 +02:00
200dbf50fc fix: remove space
Some checks failed
Continuous Delivery / build_n_upload (push) Failing after 22s
2026-04-19 12:50:53 +02:00
c17d1c49f1 ci: change repo owner 2026-04-19 12:49:30 +02:00
abb193a03c fix: add ssl dhparams in all cases
Some checks failed
Continuous Delivery / build_n_upload (push) Has been cancelled
2026-04-11 18:24:52 +02:00
5 changed files with 101 additions and 46 deletions

View File

@@ -3,7 +3,7 @@ name: Continuous Delivery
on: on:
push: push:
tags: tags:
- "v[0-9]+.[0-9]+.[0-9]+" - "**"
jobs: jobs:
build_n_upload: build_n_upload:

View File

@@ -1,12 +1,17 @@
NAME = netoik-rp NAME = netoik-rp
VERSION = $(shell git describe --abbrev=0) TAG = $(shell git describe --abbrev=0)
RELEASE = $(shell git rev-parse --short HEAD) TAG_SPLIT = $(subst -, ,$(TAG))
EPOCH = $(word 1,$(TAG_SPLIT))
VERSION = $(word 2,$(TAG_SPLIT))
RELEASE = $(word 3,$(TAG_SPLIT))
RELEASE_SPLIT = $(subst ., ,$(RELEASE))
RELEASE_NGINX = $(word 1,$(RELEASE_SPLIT)).$(word 3,$(RELEASE_SPLIT))
ARCH = noarch ARCH = noarch
OWNER = samuel OWNER = netoik
SUMMARY = "Netoïk Reverse Proxy" SUMMARY = "Netoïk Reverse Proxy"
LICENSE = "MIT" LICENSE = "MIT"
URL = "https://git.netoik.io/$(OWNER)/$(NAME)" URL = "https://git.netoik.io/$(OWNER)/$(NAME)"
SOURCE0 = "$(NAME)-$(VERSION)-$(RELEASE).tar.gz" SOURCE0 = "$(NAME)-$(EPOCH)-$(VERSION)-$(RELEASE).tar.gz"
RPM_RPMDIR = $(shell rpm --eval '%{_rpmdir}') RPM_RPMDIR = $(shell rpm --eval '%{_rpmdir}')
RPM_SBINDIR = $(shell rpm --eval '%{_sbindir}') RPM_SBINDIR = $(shell rpm --eval '%{_sbindir}')
@@ -19,12 +24,21 @@ RPM_BUILD_PATH = $(RPM_RPMDIR)/$(ARCH)/$(NAME)-$(VERSION)-$(RELEASE).$(ARCH).rpm
.PHONY: help .PHONY: help
help: help:
@grep -E '^[a-zA-Z0-9_-]+:.*?## .*' $(MAKEFILE_LIST) | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}' @grep -E '^[a-zA-Z0-9_-]+:.*?## .*' $(MAKEFILE_LIST) | \
awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'
.PHONY: name .PHONY: name
name: ## Show project name name: ## Show project name
@echo "$(NAME)" @echo "$(NAME)"
.PHONY: tag
tag: ## Show last tag
@echo "$(TAG)"
.PHONY: epoch
epoch: ## Show project epoch
@echo "$(EPOCH)"
.PHONY: version .PHONY: version
version: ## Show current project version version: ## Show current project version
@echo "$(VERSION)" @echo "$(VERSION)"
@@ -33,6 +47,10 @@ version: ## Show current project version
release: ## Show current project release release: ## Show current project release
@echo "$(RELEASE)" @echo "$(RELEASE)"
.PHONY: release_nginx
release_nginx: ## Show nginx release
@echo "$(RELEASE_NGINX)"
.PHONY: arch .PHONY: arch
arch: ## Show rpm arch target arch: ## Show rpm arch target
@echo "$(ARCH)" @echo "$(ARCH)"
@@ -57,7 +75,7 @@ url: ## Show project homepage URL
source0: ## Show rpm source0 file name source0: ## Show rpm source0 file name
@echo "$(SOURCE0)" @echo "$(SOURCE0)"
$(RPM_TARBALL_PATH): * $(RPM_TARBALL_PATH):
git archive --format=tar.gz \ git archive --format=tar.gz \
--output="$@" \ --output="$@" \
--prefix="$(NAME)-$(VERSION)/" \ --prefix="$(NAME)-$(VERSION)/" \
@@ -70,19 +88,37 @@ tarball: $(RPM_TARBALL_PATH) ## Build rpm tarball
.PHONY: install .PHONY: install
install: ## Install files into rpm dest (requires env var DESTDIR) install: ## Install files into rpm dest (requires env var DESTDIR)
@if [ -z "$(DESTDIR)" ]; then \ @if [ -z "$(DESTDIR)" ]; then \
printf "[CRITICAL] Missing env var DESTDIR\n[CRITICAL] This command is designed to be called by rpmbuild only!\n" 1>&2; \ printf "[CRITICAL] Missing env var DESTDIR\n" 1>&2; \
printf "[CRITICAL] This command is designed to be called by rpmbuild only!\n" 1>&2; \
exit 1; \ exit 1; \
fi fi
install --mode=755 --directory $(DESTDIR)$(RPM_SYSCONFDIR)/nginx/conf.d $(DESTDIR)$(RPM_SYSCONFDIR)/certbot $(DESTDIR)$(RPM_UNITDIR) $(DESTDIR)$(RPM_SBINDIR) install --mode=755 \
install --mode=644 --target-directory=$(DESTDIR)$(RPM_SYSCONFDIR)/nginx/conf.d files/nginx/0_security.conf files/nginx/z_default.conf --directory $(DESTDIR)$(RPM_SYSCONFDIR)/nginx/conf.d \
install --mode=600 --target-directory=$(DESTDIR)$(RPM_SYSCONFDIR)/certbot files/certbot/ovh.ini $(DESTDIR)$(RPM_SYSCONFDIR)/certbot \
install --mode=644 --target-directory=$(DESTDIR)$(RPM_UNITDIR) files/systemd/certbot-renew.service files/systemd/certbot-renew.timer $(DESTDIR)$(RPM_UNITDIR) \
install --mode=755 --target-directory=$(DESTDIR)$(RPM_SBINDIR) files/sbin/certbot_renew $(DESTDIR)$(RPM_SBINDIR)
install --mode=644 \
--target-directory=$(DESTDIR)$(RPM_SYSCONFDIR)/nginx/conf.d \
files/nginx/0_security.conf files/nginx/z_default.conf
install --mode=600 \
--target-directory=$(DESTDIR)$(RPM_SYSCONFDIR)/certbot \
files/certbot/ovh.ini
install --mode=644 \
--target-directory=$(DESTDIR)$(RPM_UNITDIR) \
files/systemd/certbot-renew.service \
files/systemd/certbot-renew.timer
install --mode=755 \
--target-directory=$(DESTDIR)$(RPM_SBINDIR) \
files/sbin/certbot_renew
.PHONY: upload .PHONY: upload
upload: ## Upload rpm package to Gitea repository (requires env var PKG_TOKEN) upload: ## Upload rpm package to Gitea repository (requires env var PKG_TOKEN)
@if [ -z "$(PKG_TOKEN)" ]; then \ @if [ -z "$(PKG_TOKEN)" ]; then \
printf "[CRITICAL] Missing env var PKG_TOKEN\n[CRITICAL] This command is designed to be called by Gitea Actions only!\n" 1>&2; \ printf "[CRITICAL] Missing env var PKG_TOKEN\n" 1>&2; \
printf "[CRITICAL]This command is designed to be called by Gitea Actions only!\n" 1>&2; \
exit 1; \ exit 1; \
fi fi
curl --fail-with-body --upload-file "$(RPM_BUILD_PATH)" --user "$(OWNER):$(PKG_TOKEN)" https://git.netoik.io/api/packages/$(OWNER)/rpm/upload curl --fail-with-body \
--upload-file "$(RPM_BUILD_PATH)" \
--user "$(OWNER):$(PKG_TOKEN)" \
https://git.netoik.io/api/packages/$(OWNER)/rpm/upload

View File

@@ -1,4 +1,4 @@
# Netoïk reverse proxy ![badge](https://git.netoik.io/samuel/netoik-rp/actions/workflows/ci.yaml/badge.svg) # Netoïk reverse proxy ![badge](https://git.netoik.io/netoik/netoik-rp/actions/workflows/ci.yaml/badge.svg)
Build an RPM package which will install several tools. Build an RPM package which will install several tools.
@@ -11,7 +11,7 @@ Build an RPM package which will install several tools.
- `Certbot` certificates with: - `Certbot` certificates with:
- ovh configuration to renew certs - ovh configuration to renew certs
- a command tool certbot_renew - a command tool certbot_renew
- a systemctl certbot renew timer - a systemctl Certbot renew timer
# Development # Development
@@ -32,7 +32,7 @@ A `Makefile` is integrated to let you run some basic commands.
make tarball make tarball
``` ```
- Build an rpm package: - Build a rpm package:
```shell ```shell
rpmbuild -ba netoik-rp.spec rpmbuild -ba netoik-rp.spec
``` ```
@@ -66,7 +66,7 @@ Some commands to deploy the RPM package on server
- Add Gitea repo to your repo list: - Add Gitea repo to your repo list:
```shell ```shell
dnf config-manager --add-repo https://git.netoik.io/api/packages/samuel/rpm.repo dnf config-manager --add-repo https://git.netoik.io/api/packages/netoik/rpm.repo
dnf repolist | grep gitea-samuel dnf repolist | grep gitea-samuel
``` ```
@@ -75,10 +75,10 @@ Some commands to deploy the RPM package on server
dnf search --showduplicates netoik-rp dnf search --showduplicates netoik-rp
``` ```
- Create certbot ovh credentials here: - Create Certbot ovh credentials here:
[www.ovh.com/auth/api/createToken](https://www.ovh.com/auth/api/createToken) [www.ovh.com/auth/api/createToken](https://www.ovh.com/auth/api/createToken)
- Setup environemnt file (fill values): - Setup environment file (fill values):
```shell ```shell
cat > ~/.netoik-rp.env << EOF cat > ~/.netoik-rp.env << EOF
OVH_ENDPOINT="" OVH_ENDPOINT=""
@@ -98,7 +98,7 @@ Some commands to deploy the RPM package on server
set +a set +a
``` ```
- Install or upgrade without certbot (for testing environment) - Install or upgrade without Certbot (for testing environment)
```shell ```shell
SKIP_CERTBOT=true dnf --nogpgcheck --refresh --assumeyes --best install netoik-rp SKIP_CERTBOT=true dnf --nogpgcheck --refresh --assumeyes --best install netoik-rp
``` ```

View File

@@ -1,8 +1,10 @@
%define debug_package %{nil} %define debug_package %{nil}
Name: %(make name) Name: %(make name)
Epoch: %(make epoch)
Version: %(make version) Version: %(make version)
Release: %(make release) Release: %(make release)
Summary: %(make summary) Summary: %(make summary)
License: %(make license) License: %(make license)
URL: %(make url) URL: %(make url)
@@ -10,7 +12,13 @@ URL: %(make url)
Source0: %(make source0) Source0: %(make source0)
Buildarch: %(make arch) Buildarch: %(make arch)
BuildRequires: make BuildRequires: make
Requires: nginx python3 python-devel (augeas-devel or augeas-libs) gcc openssl
Requires: nginx = %{epoch}:%{version}-%(make release_nginx)
Requires: python3
Requires: python-devel
Requires: (augeas-devel or augeas-libs)
Requires: gcc
Requires: openssl
%description %description
Install the reverse proxy called nginx with a predefined configuration and with TLS certificates attached to netoik.io Install the reverse proxy called nginx with a predefined configuration and with TLS certificates attached to netoik.io
@@ -45,7 +53,24 @@ if [ -z $SKIP_CERTBOT ]; then
# Create certbot certificates # Create certbot certificates
if ! certbot certificates --cert-name netoik.io | grep --quiet netoik.io; then if ! certbot certificates --cert-name netoik.io | grep --quiet netoik.io; then
certbot certonly --cert-name netoik.io --non-interactive --agree-tos --email samuel.campos@netoik.io --dns-ovh --dns-ovh-credentials %{_sysconfdir}/certbot/ovh.ini -d *.netoik.io -d *.samuel-campos.fr certbot certonly --cert-name netoik.io \
--non-interactive \
--agree-tos \
--email samuel.campos@netoik.io \
--dns-ovh --dns-ovh-credentials %{_sysconfdir}/certbot/ovh.ini \
-d *.netoik.io \
-d *.samuel-campos.fr
fi
else
# Skipping certbot, so create self-signed certificate
mkdir --parents /etc/letsencrypt/live/netoik.io
openssl req -newkey rsa:4096 \
-nodes \
-keyout /etc/letsencrypt/live/netoik.io/privkey.pem \
-x509 \
-days 365 \
-out /etc/letsencrypt/live/netoik.io/fullchain.pem \
-subj "/C=US/ST=State/L=City/O=Organization/OU=Department/CN=netoik.io"
fi fi
# Create ssl dh params if not already exists # Create ssl dh params if not already exists
@@ -53,12 +78,6 @@ if [ -z $SKIP_CERTBOT ]; then
openssl dhparam -out %{_sysconfdir}/letsencrypt/ssl-dhparams.pem 2048 openssl dhparam -out %{_sysconfdir}/letsencrypt/ssl-dhparams.pem 2048
fi fi
else
# Skipping certbot, so create self-signed certificate
mkdir --parents /etc/letsencrypt/live/netoik.io
openssl req -newkey rsa:4096 -nodes -keyout /etc/letsencrypt/live/netoik.io/privkey.pem -x509 -days 365 -out /etc/letsencrypt/live/netoik.io/fullchain.pem -subj "/C=US/ST=State/L=City/O=Organization/OU=Department/CN=netoik.io"
fi
# Restart services # Restart services
systemctl daemon-reload systemctl daemon-reload
systemctl reenable nginx.service certbot-renew.timer systemctl reenable nginx.service certbot-renew.timer
@@ -73,8 +92,8 @@ if [ $1 == 0 ]; then
fi fi
%files %files
%attr(644, root, root) %{_sysconfdir}/nginx/conf.d/0_security.conf %config %attr(644, root, root) %{_sysconfdir}/nginx/conf.d/0_security.conf
%attr(644, root, root) %{_sysconfdir}/nginx/conf.d/z_default.conf %config %attr(644, root, root) %{_sysconfdir}/nginx/conf.d/z_default.conf
%attr(755, root, root) %dir %{_sysconfdir}/certbot %attr(755, root, root) %dir %{_sysconfdir}/certbot
%attr(600, root, root) %{_sysconfdir}/certbot/ovh.ini %attr(600, root, root) %{_sysconfdir}/certbot/ovh.ini